---
title: WebAssembly.validate()
slug: Web/JavaScript/Reference/Global_Objects/WebAssembly/validate
tags:
  - API
  - JavaScript
  - Method
  - Object
  - Reference
  - WebAssembly
  - validate
---
<div>{{JSRef}}</div>

<p>The <strong><code>WebAssembly.validate()</code></strong> function validates a given <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed array</a> of WebAssembly binary code, returning whether the bytes form a valid wasm module (<code>true</code>) or not (<code>false</code>).</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">WebAssembly.validate(bufferSource);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>bufferSource</code></dt>
 <dd>A <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed array</a> or <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer">ArrayBuffer</a> containing WebAssembly binary code to be validated.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A boolean that specifies whether <code>bufferSource</code> is valid wasm code (<code>true</code>) or not (<code>false</code>).</p>

<h3 id="Exceptions">Exceptions</h3>

<p>If <code>bufferSource</code> is not a <a href="/en-US/docs/Web/JavaScript/Typed_arrays">typed array</a> or <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/ArrayBuffer">ArrayBuffer</a>, a {{jsxref("TypeError")}} is thrown.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_validate">Using validate</h3>

<p>The following example (see the validate.html <a href="https://github.com/mdn/webassembly-examples/blob/master/js-api-examples/validate.html">source code</a>, and <a href="https://mdn.github.io/webassembly-examples/js-api-examples/validate.html">see it live too</a>) fetches a .wasm module and converts it into a typed array. The <code>validate()</code> method is then used to check whether the module is valid.</p>

<pre class="brush: js">fetch('simple.wasm').then(response =&gt;
  response.arrayBuffer()
).then(function(bytes) {
  var valid = WebAssembly.validate(bytes);
  console.log("The given bytes are "
    + (valid ? "" : "not ") + "a valid wasm module");
});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('WebAssembly JS', '#dom-webassembly-validate', 'validate()')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.WebAssembly.validate")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/WebAssembly">WebAssembly</a> overview page</li>
 <li><a href="/en-US/docs/WebAssembly/Concepts">WebAssembly concepts</a></li>
 <li><a href="/en-US/docs/WebAssembly/Using_the_JavaScript_API">Using the WebAssembly JavaScript API</a></li>
</ul>
